import mysql.connector
import sys
from sys import exit

# Funzione per la creazione del database grassDB (se il database già
# esiste, ne cancella il contenuto)
def createDB():
	
	global hostAddress
	
	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()

	# Se il database grassDB esiste, lo cancella.
	cursor.execute("DROP database IF EXISTS grassDB")

	# Compone la query per la creazione del databse GrassDB
	sql = "CREATE database grassDB";

	# Crea il database grassDB
	cursor.execute(sql)

	# Recupera e visualizza l'elenco dei database
	# print("List of databases: ")
	# cursor.execute("SHOW DATABASES")
	# print(cursor.fetchall())
	
	# Chiude la connessione con il server mysql
	conn.close()

# Funzione per la creazione della tabella events del database grassDB
# (se la tabella già esiste, ne cancella il contenuto)
def createTableEvents():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()

	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)
	
	# Se la tabella events gia' esiste, la cancella dal database.
	cursor.execute("DROP TABLE IF EXISTS events")

	# Compone il comando sql per creare la tabella events nel database
	# grassDB
	sql = ''' CREATE TABLE events
	                      (
                          acqTimeStamp DATETIME NOT NULL,
                          eventTimeStamp BIGINT NOT NULL,
                          eventCounter INT NOT NULL,
                          channel_00 SMALLINT NOT NULL,
                          channel_01 SMALLINT NOT NULL,
                          channel_02 SMALLINT NOT NULL,
                          channel_03 SMALLINT NOT NULL,
                          channel_04 SMALLINT NOT NULL,
                          channel_05 SMALLINT NOT NULL,
                          channel_06 SMALLINT NOT NULL,
                          channel_07 SMALLINT NOT NULL,
                          channel_08 SMALLINT NOT NULL,
                          channel_09 SMALLINT NOT NULL,
                          channel_10 SMALLINT NOT NULL,
                          channel_11 SMALLINT NOT NULL,
                          channel_12 SMALLINT NOT NULL,
                          channel_13 SMALLINT NOT NULL,
                          channel_14 SMALLINT NOT NULL,
                          channel_15 SMALLINT NOT NULL,
                          PRIMARY KEY (acqTimeStamp, eventTimeStamp)
                          )'''

	# crea la tabella events nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()

# Funzione per la creazione della tabella status del database grassDB
# (se la tabella già esiste, ne cancella il contenuto)
def createTableStatus():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()
	
	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)

	# Se la tabella status gia' esiste, la cancella dal database
	cursor.execute("DROP TABLE IF EXISTS status")

	# Compone il comando sql per creare la tabella status nel database
	# grassDB
	sql = ''' CREATE TABLE status(
                    acqTimeStamp DATETIME NOT NULL PRIMARY KEY,
                    deviceId VARCHAR(100) NOT NULL,
                    allVoltagesGood BOOLEAN NOT NULL,
                    deviceActivated BOOLEAN NOT NULL
                    )'''

	# Crea la tabella status nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()
	
# Funzione per la creazione della tabella mainVoltages del database
# grassDB (se la tabella già esiste, ne cancella il contenuto)
def createTableMainVoltages():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()
	
	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)

	# Se la tabella mainVoltages gia' esiste, la cancella dal database
	cursor.execute("DROP TABLE IF EXISTS mainVoltages")

	# Compone il comando sql per creare la tabella mainVoltages nel
	# database grassDB
	sql = ''' CREATE TABLE mainVoltages(
                    acqTimeStamp DATETIME NOT NULL PRIMARY KEY,
                    3_3V DECIMAL(4,2) NOT NULL,
                    5_0V DECIMAL(4,2) NOT NULL,
                    plusVA DECIMAL(4,2) NOT NULL,
                    minusVA DECIMAL(4,2) NOT NULL
                    )'''
                    
	# Crea la tabella mainVoltages nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()

# Funzione per la creazione della tabella mainVoltageStatus del
# database grassDB (se la tabella già esiste, ne cancella il contenuto)
def createTableMainVoltageStatus():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()
	
	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)

	# Se la tabella mainVoltageStatuss gia' esiste, la cancella dal
	# database
	cursor.execute("DROP TABLE IF EXISTS mainVoltageStatus")

	# Compone il comando sql per creare la tabella mainVoltageStatus nel
	# database grassDB	
	sql = ''' CREATE TABLE mainVoltageStatus(
                    acqTimeStamp DATETIME NOT NULL PRIMARY KEY,
                    3_3V BOOLEAN NOT NULL,
                    5_0V BOOLEAN NOT NULL,
                    plusVA BOOLEAN NOT NULL,
                    minusVA BOOLEAN NOT NULL
                    )'''

	# Crea la tabella mainVoltageStatus nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()	

# Funzione per la creazione della tabella triggerTimings del database
# grassDB (se la tabella già esiste, ne cancella il contenuto)
def createTableTriggerTimings():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()
	
	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)

	# Se la tabella triggerTimings gia' esiste, la cancella dal database
	cursor.execute("DROP TABLE IF EXISTS triggerTimings")
	
	# Compone il comando sql per creare la tabella triggerTimings nel
	# database grassDB
	sql = ''' CREATE TABLE TRIGGERTIMINGS(
                    acqTimeStamp DATETIME NOT NULL,
                    triggerSource VARCHAR(100) NOT NULL,
                    integrationTime INT NOT NULL,
                    triggerDelay INT NOT NULL,
                    triggerDeadTime INT NOT NULL,
                    triggerDelayModality BOOLEAN NOT NULL
                    )'''

	# Crea la tabella triggerTimings nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()
	
	
# Funzione per la creazione della tabella triggerGenerators del database
# grassDB (se la tabella già esiste, ne cancella il contenuto)
def createTableTriggerGenerators():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()
	
	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)

	# Se la tabella triggerGenerators gia' esiste, la canPRIMARY KEY (acqTimeStamp, eventTimeStamp)cella dal
	# database
	cursor.execute("DROP TABLE IF EXISTS triggerGenerators")
	
	# Compone il comando sql per creare la tabella triggerGenerators nel
	# database grassDB
	sql = ''' CREATE TABLE triggerGenerators(
                    acqTimeStamp DATETIME NOT NULL,
                    triggerInterval INT NOT NULL,
                    triggerCount INT NOT NULL,
                    triggers INT NOT NULL,
                    triggerRate INT NOT NULL,
                    adcConversions INT NOT NULL,
                    threshold INT NOT NULL
                    )'''

	# Crea la tabella triggerGenerators nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()
	
# Funzione per la creazione della tabella discriminators del database
# grassDB (se la tabella già esiste, ne cancella il contenuto)
def createTableDiscriminators():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()
	
	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)

	# Se la tabella discriminators gia' esiste, la cancella dal
	# database
	cursor.execute("DROP TABLE IF EXISTS discriminators")
	
	# Compone il comando sql per creare la tabella discriminators nel
	# database grassDB
	sql = ''' CREATE TABLE discriminators(
	                acqTimeStamp DATETIME NOT NULL,
                    threshold VARCHAR (100),
                    sumGain DECIMAL (5,2) NOT NULL,
                    sumOffset DECIMAL (5,2) NOT NULL
                    )'''

	# Crea la tabella discriminators nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()

# Funzione per la creazione della tabella adcs del database
# grassDB (se la tabella già esiste, ne cancella il contenuto)
def createTableAdcs():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()
	
	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)

	# Se la tabella adcs gia' esiste, la cancella dal
	# database
	cursor.execute("DROP TABLE IF EXISTS adcs")
	
	# Compone il comando sql per creare la tabella adcs nel
	# database grassDB
	sql = ''' CREATE TABLE adcs(
                    acqTimeStamp DATETIME NOT NULL PRIMARY KEY,
                    bufferWords INT NOT NULL,
                    addTimeStamp BOOLEAN NOT NULL,
                    addEventCount BOOLEAN NOT NULL,
                    addChannelNumber BOOLEAN NOT NULL,
                    addTriggerSource BOOLEAN NOT NULL,
                    inputCoupling VARCHAR(100) NOT NULL,
                    gainCh_01 DECIMAL (5,2) NOT NULL,
                    gainCh_02 DECIMAL (5,2) NOT NULL,
                    gainCh_03 DECIMAL (5,2) NOT NULL,
                    gainCh_04 DECIMAL (5,2) NOT NULL,
                    gainCh_05 DECIMAL (5,2) NOT NULL,
                    gainCh_06 DECIMAL (5,2) NOT NULL,
                    gainCh_07 DECIMAL (5,2) NOT NULL,
                    gainCh_08 DECIMAL (5,2) NOT NULL,
                    gainCh_09 DECIMAL (5,2) NOT NULL,
                    gainCh_10 DECIMAL (5,2) NOT NULL,
                    gainCh_11 DECIMAL (5,2) NOT NULL,
                    gainCh_12 DECIMAL (5,2) NOT NULL,
                    gainCh_13 DECIMAL (5,2) NOT NULL,
                    gainCh_14 DECIMAL (5,2) NOT NULL,
                    gainCh_15 DECIMAL (5,2) NOT NULL,
                    gainCh_16 DECIMAL (5,2) NOT NULL,
                    offsetCh_01 DECIMAL (5,2) NOT NULL,
                    offsetCh_02 DECIMAL (5,2) NOT NULL,
                    offsetCh_03 DECIMAL (5,2) NOT NULL,
                    offsetCh_04 DECIMAL (5,2) NOT NULL,
                    offsetCh_05 DECIMAL (5,2) NOT NULL,
                    offsetCh_06 DECIMAL (5,2) NOT NULL,
                    offsetCh_07 DECIMAL (5,2) NOT NULL,
                    offsetCh_08 DECIMAL (5,2) NOT NULL,
                    offsetCh_09 DECIMAL (5,2) NOT NULL,
                    offsetCh_10 DECIMAL (5,2) NOT NULL,
                    offsetCh_11 DECIMAL (5,2) NOT NULL,
                    offsetCh_12 DECIMAL (5,2) NOT NULL,
                    offsetCh_13 DECIMAL (5,2) NOT NULL,
                    offsetCh_14 DECIMAL (5,2) NOT NULL,
                    offsetCh_15 DECIMAL (5,2) NOT NULL,
                    offsetCh_16 DECIMAL (5,2) NOT NULL
                    )'''

	# Crea la tabella adcs nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()

# Funzione per la creazione della tabella detectorModules del database
# grassDB (se la tabella già esiste, ne cancella il contenuto)
def createDetectorModules():

	# stabilisce la connessione con il server mysql
	conn = mysql.connector.connect( \
	                              user='grass', \
	                              password='hemera2022', \
	                              host=hostAddress \
	                              )

	# Crea un cursore
	cursor = conn.cursor()
	
	# Compone il comando sql per selezionare grassDB quale database di
	# default
	sql = '''USE grassDB'''
	
	# seleziona grassDB quale database di default
	cursor.execute(sql)

	# Se la tabella detectorModules gia' esiste, la cancella dal
	# database
	cursor.execute("DROP TABLE IF EXISTS detectorModules")
	
	# Compone il comando sql per creare la tabella detectorModules nel
	# database grassDB
	sql = ''' CREATE TABLE detectorModules (
                          acqTimeStamp DATETIME NOT NULL PRIMARY KEY,
                          temperatureValid BOOLEAN NOT NULL,
                          plusVAStatus BOOLEAN NOT NULL,
                          minusVAStatus BOOLEAN NOT NULL,
                          plusMinusVAEnabled BOOLEAN NOT NULL,
                          plusMinusVALevel DECIMAL(5,2) NOT NULL,
                          hvStatus BOOLEAN NOT NULL,
                          hvEnabled BOOLEAN NOT NULL,
                          detectorTemperature DECIMAL(5,2) NOT NULL,
                          boardTemperature DECIMAL(5,2) NOT NULL,
                          plusVAVoltage DECIMAL(5,2) NOT NULL,
                          minusVAVoltage DECIMAL(5,2) NOT NULL,
                          hvCurrentMonitor DECIMAL(5,2) NOT NULL,
                          hvVoltageMonitor DECIMAL(5,2) NOT NULL,
                          hvVoltageSetting DECIMAL(5,2) NOT NULL,
                          hvCurrentLimitSetting DECIMAL(5,2) NOT NULL,
                          hvMaximumSettingVoltage DECIMAL(5,2) NOT NULL,
                          hvRampRateSetting DECIMAL(5,2) NOT NULL
                          )'''

	# Crea la tabella detectorModules nel database grassDB
	cursor.execute(sql)

	# Chiude la connessione con il server mysql
	conn.close()
	
##############################################################

# Controllo numero argomenti a linea di comand
if (len(sys.argv) != 2):
	print ("Syntax:")
	print ("initializeGrassDb <Server address>")
	exit ()

# Estrazione dalla linea di comando l'indirizzo del server mysql
hostAddress = sys.argv[1]

# Chiama la funzione per la creazione del database grassDB
createDB()

# Chiama la funzione per la creazione della tabella events
# del database grassDB
createTableEvents()

# Chiama la funzione per la creazione della tabella status
# del database grassDB
createTableStatus()

# Chiama la funzione per la creazione della tabella mainVoltages
# del database grassDB
createTableMainVoltages()

# Chiama la funzione per la creazione della tabella mainVoltageStatus
# del database grassDB
createTableMainVoltageStatus()

# Chiama la funzione per la creazione della tabella triggerTimings
# del database grassDB
createTableTriggerTimings()

# Chiama la funzione per la creazione della tabella triggerGenerators
# del database grassDB
createTableTriggerGenerators()

# Chiama la funzione per la creazione della tabella discriminators
# del database grassDB
createTableDiscriminators()

# Chiama la funzione per la creazione della tabella adcs
# del database grassDB
createTableAdcs()

# Chiama la funzione per la creazione della tabella detectorModules
# del database grassDB
createDetectorModules()
